<?php
/**
 * jDownloads Categories - shows categories list from the component jDownloads
 *
 * @version 1.0
 * @author smart (smart@joomlatune.ru)
 * @copyright (C) 2009 by smart (http://www.joomlatune.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 **/
 
// ensure this file is being included by a parent file
(defined('_VALID_MOS') OR defined('_JEXEC')) or die('Direct Access to this location is not allowed.');

if (!function_exists('jdownloads_cats_build_html')) { 
	function jdownloads_cats_build_html( $id, $html, $children, $native, $Itemid, $active, $level = 0, $maxlevel = 9999) {

		if (isset($children[$id]) && $level <= $maxlevel) {

			foreach ($children[$id] as $v) {

				if ($native) {
					$link = JRoute::_('index.php?option=com_jdownloads&amp;task=viewcategory&catid=' . $v->id);
				} else {
					$link = sefRelToAbs('index.php?option=com_jdownloads&amp;Itemid=' . $Itemid . '&amp;task=viewcategory&catid=' . $v->id);
				}

				$html .= '<li>';

				if ($v->id == $active) {
					$html .= '<span class="active">' . $v->title . '</span>';
				} else {
					$html .= '<a href="' . $link . '" title="' . $v->title . '">' . $v->title . '</a>';
				}

				$nested_html = jdownloads_cats_build_html($v->id, '', $children, $native, $Itemid, $active, $level + 1);

				if ($nested_html != '') {
					$html .= '<ul>' . $nested_html . '</ul>';
				}

				$html .= '</li>';
			}
		}
		return $html;
	}
}

global $my;

if (defined('_JEXEC')) {
	$native = 1;

	$dbo = & JFactory::getDBO();
	$option = JRequest::getCmd('option');
	$catid = JRequest::getVar( 'catid', -1, '', 'int' );
} else {
	global $database;

	$native = 0;
	$dbo = $database;
	$dbo->setQuery("SELECT id from #__menu WHERE link = 'index.php?option=com_jdownloads' and published = 1");
	$Itemid = $dbo->loadResult();

	$option = mosGetParam($_REQUEST, 'option', '');
	$catid = mosGetParam($_REQUEST, 'catid', -1);
	
	if (!$Itemid) {
		$Itemid = 999999;
	}
}

if ($option != 'com_jdownloads') {
	$catid = -1;
}


$access = '';

switch($my->gid) {
	case 0:
		$access = '01';
		break;
	case 1:
		$access = '11';
		break;
	case 2:
		$access = '22';
		break;
	default:
		$access = '';
}

$where = array();
$where[] = 'published = 1';
$where[] = 'cat_access <= ' . $access;

$dbo->setQuery('SELECT cat_id as id, cat_title as title, parent_id as parent FROM #__jdownloads_cats WHERE '. implode(' AND ', $where ) . ' ORDER BY parent_id, ordering');
$cats = $dbo->loadObjectList();

$html = '<ul class="categories' . $params->get('moduleclass_sfx') . '">';
    
if (count($cats)) {
	$children = array();
	foreach ($cats as $v) {
		$pt = $v->parent;
		$list = isset($children[$pt]) ? $children[$pt] : array();
		array_push($list, $v);
		$children[$pt] = $list;
	}

	$html .= jdownloads_cats_build_html(0, '', $children, $native, $Itemid, $catid);
}

$html .= '</ul>';

echo $html; 
?>